
Redmine - Feature #31355

Bookmarks and recently used projects for the project jump box
Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Projects Estimated time: 0.00 hour

Target version: 4.1.0   

Resolution:    

Description

This patch aims to make the project jump box (project selector in top right corner) more useful especially for installations / users with

many projects.

adds a bookmarking feature to the project overview page

users can bookmark any project they have access to

bookmarked projects will be rendered in a separate section in the jump box, on the top.

the 3 most recently used projects will be rendered in a second section of the jump box. That number may be changed in the

user's account preferences

bookmarked projects are excluded from that list

the last section of the jump box holds any other projects that would have been rendered in the jump box originally but are not

already shown in one of the previous sections.

all 3 sections will be filtered according to a given query string in the search box

favorites and other projects lists are rendered as trees, recently used projects as a flat list ordered by time of last use

recently used and bookmarked projects are stored as serialized arrays of project IDs in the user preferences.
Related issues:

Related to Redmine - Patch #31356: replace icon-fav with icon-user for 'my pr... Closed

Related to Redmine - Defect #31411: Internal Error (r18182) Closed

Related to Redmine - Defect #31508: Add missing frozen strings and copyrights Closed

Related to Redmine - Feature #32302: Filter projects after bookmarks Closed

Related to Redmine - Feature #572: My projects (or favourite projects) Closed

Related to Redmine - Defect #32503: Project jump box options are not extracte... Closed

Related to Redmine - Feature #7751: Filter projects dropdown menu Closed 2011-03-02

Related to Redmine - Feature #32944: Always preserve the tree structure in th... Closed

Has duplicate Redmine - Feature #7339: Add a favorites Project list. Closed 2011-01-15

Associated revisions

Revision 18181 - 2019-05-21 00:26 - Go MAEDA

Adds favorites and recently used projects lists to project jump box (#31355).

Patch by Jens Krämer.

Revision 18182 - 2019-05-21 00:29 - Go MAEDA

Update locales (#31355).

Revision 18183 - 2019-05-21 10:28 - Go MAEDA

Fix an error "uninitialized constant Redmine::ProjectJumpBox" in the production environment (#31355).

Revision 18842 - 2019-10-23 03:20 - Go MAEDA

Option to filter after my bookmarked projects (#32302, #29482, #31355).

Patch by Marius BALTEANU.
Revision 18843 - 2019-10-23 03:27 - Go MAEDA

Update locales (#32302, #29482, #31355).

Revision 19325 - 2019-12-02 02:37 - Go MAEDA

Fix that bookmarked and recently used projects are unexpectedly filtered by a search keyword after full-text search (#31355, #32503).

Patch by Mizuki ISHIKAWA.

Revision 19326 - 2019-12-02 03:21 - Go MAEDA

Merged r19325 from trunk to 4.1-stable (#31355, #32503).

History

#1 - 2019-05-13 09:41 - Go MAEDA

- Target version set to Candidate for next major release

#2 - 2019-05-13 11:25 - Go MAEDA

- Related to Patch #31356: replace icon-fav with icon-user for 'my projects' added

#3 - 2019-05-14 01:20 - Go MAEDA

I like this change. Users generally be a member of many projects, but the projects they usually use is not so many. With this change, they can quickly

go to the project they are currently working on.

#4 - 2019-05-20 06:03 - Bernhard Rohloff

I've tried the patch and it makes project switching very fast and easy. A really great improvement for Redmine!

+1

#5 - 2019-05-20 06:25 - Bernhard Rohloff

Oh, one thing I forgot is, the patch doesn't contain the two new icons referenced by the stylesheet changes.

.icon-bookmark { background-image: url(../images/tag_blue_delete.png); }

.icon-bookmark-off { background-image: url(../images/tag_blue_add.png); }

#6 - 2019-05-20 07:40 - Go MAEDA

- File tag_blue_add.png added

- File tag_blue_delete.png added

Bernhard Rohloff wrote:

Oh, one thing I forgot is, the patch doesn't contain the two new icons referenced by the stylesheet changes.

[...]

 The icons are included in the patch. You can get them by using git apply instead of patch command.

#7 - 2019-05-20 09:15 - Marius BĂLTEANU

The patch looks very good to me. I'm in favour of delivering this feature in 4.1.0.

#8 - 2019-05-20 09:26 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

I am sure that no one will dislike or oppose this feature. Let's deliver this feature in 4.1.0.

#9 - 2019-05-21 00:30 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patches. Thank you for contributing the great improvement.
#10 - 2019-05-21 02:29 - Go MAEDA

- Status changed from Closed to Reopened

It does not work in production mode.

Started GET "/" for 127.0.0.1 at 2019-05-21 09:26:20 +0900

Processing by WelcomeController#index as HTML

  Current user: anonymous

  Rendering welcome/index.html.erb within layouts/base

  Rendered collection of news/_news.html.erb [2 times] (66.0ms)

  Rendered welcome/index.html.erb within layouts/base (134.1ms)

Completed 500 Internal Server Error in 423ms (ActiveRecord: 14.2ms)

ActionView::Template::Error (uninitialized constant Redmine::ProjectJumpBox):

    79:         <%= hidden_field_tag(controller.default_search_scope, 1, :id => nil) if controller.default_sea

rch_scope %>

    80:         <label for='q'>

    81:           <%= link_to l(:label_search), {:controller => 'search', :action => 'index', :id => @project,

 :scope => default_search_project_scope}, :accesskey => accesskey(:search) %>:

    82:         </label>

    83:         <%= text_field_tag 'q', @question, :size => 20, :class => 'small', :accesskey => accesskey(:qu

ick_search) %>

    84:         <% end %>

    85:         <%= render_project_jump_box %>

app/helpers/application_helper.rb:428:in `render_projects_for_jump_box'

app/helpers/application_helper.rb:478:in `render_project_jump_box'

app/views/layouts/base.html.erb:82:in `_app_views_layouts_base_html_erb__3861390146296937614_70221623652380'

lib/redmine/sudo_mode.rb:65:in `sudo_mode'

#11 - 2019-05-21 02:43 - Go MAEDA

The following change fixes #31355#note-10.

diff --git a/lib/redmine.rb b/lib/redmine.rb

index 805418d3d..7c06ac344 100644

--- a/lib/redmine.rb

+++ b/lib/redmine.rb

@@ -43,6 +43,7 @@ require 'redmine/field_format'

 require 'redmine/menu_manager'

 require 'redmine/notifiable'

 require 'redmine/platform'

+require 'redmine/project_jump_box'

 require 'redmine/mime_type'

 require 'redmine/search'

 require 'redmine/syntax_highlighting'

#12 - 2019-05-21 10:30 - Go MAEDA

- Status changed from Reopened to Closed

Committed the fix in #31355#note-10.

#13 - 2019-05-21 10:31 - Go MAEDA

- Related to Defect #31411: Internal Error (r18182) added

#14 - 2019-06-04 08:40 - Go MAEDA

- Related to Defect #31508: Add missing frozen strings and copyrights added

#15 - 2019-08-12 04:46 - Go MAEDA

- Has duplicate Feature #7339: Add a favorites Project list. added

#16 - 2019-08-29 14:42 - Vladimir Arkhipov

Do you have any plans to improve this patch to fix problem with many projects from #31908 ?

#17 - 2019-08-30 02:22 - Go MAEDA

- Category changed from UI to Projects
#18 - 2019-10-19 22:43 - Marius BĂLTEANU

- Related to Feature #32302: Filter projects after bookmarks added

#19 - 2019-10-20 17:20 - Marius BĂLTEANU

- Has duplicate Feature #572: My projects (or favourite projects) added

#20 - 2019-10-20 17:20 - Marius BĂLTEANU

- Has duplicate deleted (Feature #572: My projects (or favourite projects))

#21 - 2019-10-20 17:21 - Marius BĂLTEANU

- Related to Feature #572: My projects (or favourite projects) added

#22 - 2019-11-29 06:40 - Go MAEDA

- Related to Defect #32503: Project jump box options are not extracted correctly after searching added

#23 - 2019-11-29 06:41 - Go MAEDA

- Status changed from Closed to Reopened

An issue caused by this feature is reported as #32503.

#24 - 2019-12-02 02:42 - Go MAEDA

- Status changed from Reopened to Closed

Go MAEDA wrote:

An issue caused by this feature is reported as #32503.

 Fixed in r19325. The issue was that bookmarked and recently used projects are unexpectedly filtered by a search keyword after full-text search.

#25 - 2019-12-20 10:05 - Jean-Philippe Lang

- Tracker changed from Patch to Feature

#26 - 2020-06-06 07:02 - Go MAEDA

- Related to Feature #7751: Filter projects dropdown menu added

#27 - 2020-07-04 03:04 - Go MAEDA

- Related to Feature #32944: Always preserve the tree structure in the project jump box added

#28 - 2021-10-06 10:41 - Joaquim Homrighausen

Any chance of getting Bookmarks on an issue level?

#29 - 2022-02-02 09:58 - SS RR

Nothing happens when deleting a bookmark.

https://redmine.domain/projects/project/bookmark

ActionController::RoutingError (No route matches [GET] "/projects/project/bookmark"):

Files

0001-adds-favorites-and-recently-used-projects-lists-to-p.patch 22.6 KB 2019-05-13 Jens Krämer

jumpbox.png 10.3 KB 2019-05-13 Jens Krämer

addbookmark.png 5.17 KB 2019-05-13 Jens Krämer

tag_blue_add.png 671 Bytes 2019-05-20 Go MAEDA

tag_blue_delete.png 701 Bytes 2019-05-20 Go MAEDA
